# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#


%define section		free
#%define j2ee12  %{?_with_j2ee12:1}%{!?_without_j2ee12:0}
#%define j2ee13  %{?_with_j2ee13:1}%{!?_without_j2ee13:0}

Name:		mockobjects
Version:	0.09
Release:	17%{dist}
Epoch:		0
Summary:	Java MockObjects package
License:	BSD Style
URL:		http://www.mockobjects.com/
Group:		Development/Testing
#Vendor:         JPackage Project
#Distribution:   JPackage
Source0:	http://www.mockobjects.com/dist/%{name}-%{version}.tar.gz
Source1:        http://repo1.maven.org/maven2/mockobjects/mockobjects-core/0.09/mockobjects-core-0.09.pom
Source2:        http://repo1.maven.org/maven2/mockobjects/mockobjects-jdk1.4/0.09/mockobjects-jdk1.4-0.09.pom
Source3:        http://repo1.maven.org/maven2/mockobjects/mockobjects-alt-jdk1.4/0.09/mockobjects-alt-jdk1.4-0.09.pom
Source4:        mockobjects-httpclient-0.09.pom
Source5:        mockobjects-alt-httpclient-0.09.pom
Source6:        mockobjects-jdk1.4-j2ee1.4-0.09.pom
Patch0:		%{name}-buildjdk.patch
Patch1:		%{name}-ext-httpmethod-abstract.patch
Patch2:		%{name}-AssertMo.patch
Patch3:		%{name}-MockPageContext.patch
Patch4:		%{name}-MockConnection.patch
Patch5:		%{name}-MockMessagePublisher.patch
Patch6:		%{name}-MockQueueConnectionFactory.patch
Patch7:		%{name}-MockQueueSender.patch
Patch8:		%{name}-MockSession.patch
Patch9:		%{name}-MockTopicConnectionFactory.patch
Patch10:	mockobjects-0.09-j2ee14-MockHttpServletRequest.patch
Patch11:	mockobjects-0.09-j2ee14-MockHttpServletResponse.patch
Patch12:	mockobjects-FileImpl.patch

Requires:	java >= 0:1.4.2
Requires:	junit

BuildRequires:	java-devel = 0:1.5.0
BuildRequires:	ant >= 0:1.6.5
BuildRequires:	ant-junit
BuildRequires:	jakarta-commons-httpclient
BuildRequires:	junit
BuildRequires:	geronimo-j2ee-1.4-apis
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5


%description
The Mock Objects project is a generic unit testing framework whose goal
is to facilitate developing unit tests in the mock object style. The
goal of this project is to provide, a core mock objects framework. This
is a library of code that supports the implementation of mock objects.
It is based around a set of expectation classes for values and
collections. There are also various other classes to make mock objects
easier to write or to use.

%package jdk1.4
Summary:	MockObjects for 1.4 JDK
Group:		Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 0:1.4.2

%description jdk1.4
MockObjects specific to JDK >= 1.4.x

%package httpclient
Summary:	MockObjects for Commons HttpClient
Group:		Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	jakarta-commons-httpclient

%description httpclient
MockObjects for Jakarta Commons HttpClient

%package alt-httpclient
Summary:        Mockable API for Commons HttpClient
Group:          Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-httpclient = %{epoch}:%{version}-%{release}
Requires:	jakarta-commons-httpclient

%description alt-httpclient
Alternative API for Jakarta Commons HttpClient to allow for testing

%package alt-jdk1.4
Summary:        Mockable API for JDK 1.4
Group:          Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-jdk1.4 = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 0:1.4.2

%description alt-jdk1.4
Alternative API for JDK 1.4 to allow for testing

%package jdk1.4-j2ee1.4
Summary:        Mockable J2EE API for JDK 1.4 and J2EE 1.4
Group:          Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-jdk1.4 = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 0:1.4.2

%description jdk1.4-j2ee1.4
API for JDK 1.4 to allow testing with J2EE 1.4 mocks

%prep
%setup -q -n %{name}-%{version}
cp -r src/j2ee/1.3/com/mockobjects/servlet src/j2ee/1.4/com/mockobjects/
%patch0 -b .sav0
%patch1 -p1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4
%patch5 -b .sav5
%patch6 -b .sav6
%patch7 -b .sav7
%patch8 -b .sav8
%patch9 -b .sav9
%patch10 -b .sav10
%patch11 -b .sav11
%patch12 -b .sav12


%build
export JAVA_HOME=%{_jvmdir}/java-1.5.0
CLASSPATH=`build-classpath junit` ant jar-core
CLASSPATH=`build-classpath junit` ant jar-jdk
CLASSPATH=`build-classpath jakarta-commons-httpclient junit` ant jar-ext-httpclient
rm -rf out/j2ee/classes/*
CLASSPATH=`build-classpath geronimo-j2ee-1.4-apis junit` ant -Djdk.version=1.4 -Dj2ee.version=1.4 compile-j2ee jar-j2ee

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

pushd out
install -m 644 %{name}-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-core-%{version}.jar
install -m 644 %{name}-httpclient.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-httpclient-%{version}.jar
install -m 644 alt-httpclient.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-alt-httpclient-%{version}.jar

# Install JDK Mocks and alternatives
install -m 644 %{name}-jdk1.4-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-jdk1.4-%{version}.jar
install -m 644 %{name}-alt-jdk1.4-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-alt-jdk1.4-%{version}.jar

# Install J2EE Mocks
install -m 644 %{name}-jdk1.4-j2ee1.4-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-jdk1.4-j2ee1.4-%{version}.jar

popd

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-mockobjects-core.pom
%add_to_maven_depmap %{name} %{name}-core %{version} JPP %{name}-core
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-mockobjects-jdk1.4.pom
%add_to_maven_depmap %{name} %{name}-jdk1.4 %{version} JPP %{name}-jdk1.4
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-mockobjects-alt-jdk1.4.pom
%add_to_maven_depmap %{name} %{name}-alt-jdk1.4 %{version} JPP %{name}-alt-jdk1.4
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-mockobjects-httpclient.pom
%add_to_maven_depmap %{name} %{name}-httpclient %{version} JPP %{name}-httpclient
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-mockobjects-alt-httpclient.pom
%add_to_maven_depmap %{name} %{name}-alt-httpclient %{version} JPP %{name}-alt-httpclient
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-mockobjects-jdk1.4-j2ee1.4.pom
%add_to_maven_depmap %{name} %{name}-jdk1.4-j2ee1.4 %{version} JPP %{name}-jdk1.4-j2ee1.4

pushd $RPM_BUILD_ROOT%{_javadir} 
for jar in *-%{version}.jar; do
	ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
done
popd

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap


%files
%defattr(0644,root,root,0755)
%doc doc/README
%{_javadir}/%{name}-core*
%{_datadir}/maven2/poms
%{_mavendepmapfragdir}

%files jdk1.4
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-jdk1.4-%{version}.jar
%{_javadir}/%{name}-jdk1.4.jar

%files httpclient
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-httpclient*.jar

%files alt-jdk1.4
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-alt-jdk1.4*.jar

%files alt-httpclient
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-alt-httpclient*.jar

%files jdk1.4-j2ee1.4
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-jdk1.4-j2ee1.4*.jar

%changelog
* Tue Jul 01 2008 Ralph Apel <r.apel at r-apel.de> 0.09-17.jpp5
- Build with and for Java5
- Name mockobjects-jdk1.4 now meaning >= 1.4.2
- Packages may still be used with java-1.4.2
- Dropping any java-ext and java-1.X.Y support: 
  put everything in _javadir as there will probably
  be no new version for java5,6,7
- Add poms and depmap frags

* Mon Oct 09 2006 Ralph Apel <r.apel at r-apel.de> 0.09-16jpp
- Copy j2ee-1.3 servlet mockobjects to j2ee-1.4 subpackage
  and patch to servlet-2.4

* Wed Sep 13 2006 Ralph Apel <r.apel at r-apel.de> 0.09-15jpp
- Build j2ee-1.4 mockobjects by default
- Build either j2ee-1.2 or j2ee-1.3 instead, if told to
- Add gcj_support option

* Fri Jul 21 2006 Matt Wringe <mwringe at redhat.com> 0.09-14jpp
- Add conditional native compiling
- Remove unnecessary provides and empty %pre and %post section

* Fri Apr 28 2006 Fernando Nasser <fnasser@redhat.com> 0.09-13jpp
- First JPP 1.7 build

* Mon Dec 13 2004 Ralph Apel <r.apel at r-apel.de> 0.09-12jpp
- Build j2ee mockobjects

* Thu Sep 23 2004 Ralph Apel <r.apel at r-apel.de> 0.09-11jpp
- Optionally activate j2ee mockobjects

* Mon Aug 23 2004 Fernando Nasser <fnasser@redhat.com> 0.09-10jpp
- Remove support for 1.3 SDK
- Rebuild with Ant 1.6.2

* Tue May 18 2004 Paul Nasrat <pauln@truemesh.com> 0.09-9jpp
- Fix spurious 1.4.1 requires in jdk14

* Thu Jun 26 2003 Paul Nasrat <pauln@truemesh.com> 0.09-8jpp
- Re-jigged alt/jvm symlinks to jars rather than dirs

* Tue Jun 24 2003 Paul Nasrat <pauln@truemesh.com> 0.09-7jpp
- Multi jvm symlinks

* Thu Jun 19 2003 Paul Nasrat <pauln@truemesh.com> 0.09-6jpp
- Use java-ext for JDK specific extensions/alternatives

* Thu Jun 19 2003 Paul Nasrat <pauln@truemesh.com> 0.09-5jpp
- Split alternative APIs - as advised by Jeff Martin

* Wed Jun 18 2003 Paul Nasrat <pauln@truemesh.com> 0.09-4jpp
- BuildRequires sdk rather than jdk

* Wed Jun 18 2003 Paul Nasrat <pauln@truemesh.com> 0.09-3jpp
- BuildRequires multiple jdk

* Wed Jun 18 2003 Paul Nasrat <pauln@truemesh.com> 0.09-2jpp
- Broken up into subpackages
- Patch to build jdk-jar (commited upstream)
- Patch to build httpclient (discussed with upstream)

* Wed Mar 05 2003 Jeff Martin <jeff@custommonkey.org> 0.08-1
- first release
